describe.data.frame <-
function (x, descript, exclude.missing = TRUE, digits = 4, ...)
{
    if (missing(descript))
        descript <- as.character(sys.call())[2]
    nam <- names(x)
    Z <- list()
    nams <- character(0)
    i <- 0
    missing.vars <- NULL
    for (xx in x) {
        mat <- is.matrix(xx)
        i <- i + 1
        z <- if (mat)
            describe.matrix(xx, nam[i], exclude.missing = exclude.missing,
                digits = digits, ...)
        else describe.vector2(xx, nam[i], exclude.missing = exclude.missing,
            digits = digits, ...)
        all.missing <- length(z) == 0
        if (exclude.missing && all.missing)
            missing.vars <- c(missing.vars, nam[i])
        else {
            Z <- c(Z, if (mat) z else list(z))
            nams <- c(nams, if (mat) names(z) else nam[i])
        }
    }
    names(Z) <- nams
    attr(Z, "descript") <- descript
    attr(Z, "dimensions") <- dim(x)
    attr(Z, "missing.vars") <- missing.vars
    structure(Z, class = "describe")
}
